
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include "cheat.h"
#include "system.h"
#include "script.h"
#include "config.h"
#include "def.h"

CHEAT *Cheats    = (CHEAT *)0; // pointer to cheats in memory
int    NumCheats = 0;          // total number of cheats in memory

// used to store cheats names
static char *names_base      = (char *)0;
static int   names_base_size = 0;
static int   names_base_used = 0;

// used to store cheats memory address
static unsigned long *address_base      = (unsigned long *)0;
static int            address_base_size = 0;
static int            address_base_used = 0;

BOOL Cheat_Init(const char *szFile)
{
  char          szName[32], szBuf[MAX_STRING], *s;
  SCRIPT_FILE  *sFile;
  int           n, nCheats;
  BOOL          bExist;
  CHEAT         c;
  unsigned      nDefDataSize;

  Cheat_Quit(); // release previous cheats

  // trying to load cheats file
  sFile = Script_Load(szFile);
  if(!sFile) return FALSE; // no cheat file

  // getting the total number of cheats in the file
  nCheats = Script_GetInt(sFile, "NumberOfCheats", 0, (BOOL *)0);
  if(nCheats <= 0) return Script_Free(sFile), FALSE;

  // alloc memory to store all cheats
  Cheats = (CHEAT *)malloc(nCheats * sizeof(CHEAT));
  if(!Cheats) return Script_Free(sFile), FALSE;

  nDefDataSize = Script_GetInt(sFile, "DefaultDataSize", 8, (BOOL *)0);
  if(nDefDataSize != 32 && nDefDataSize != 16) nDefDataSize = 8;

  // reading cheats
next:
  for(n = 0; n < nCheats; n++)
  {
    s = sprintf(szName, "Cheat[%i].", n) + szName;
    strcpy(s, "Name");
    // cheat name
    c.NameLen = Script_GetString(sFile, szName, "", 0, szBuf, MAX_STRING, &bExist);
    if(bExist)
    {
      strcpy(s, "Address");
      c.NumAddress = Script_GetNumberOfInts(sFile, szName);
      if(c.NumAddress > 0)
      {
        strcpy(s, "Value");
        c.Value = Script_GetInt(sFile, szName, 0, &bExist);
        if(bExist)
        {
          strcpy(s, "DataSize");
          c.DataSize = Script_GetInt(sFile, szName, nDefDataSize, (BOOL *)0);
          if(c.DataSize != 32 && c.DataSize != 16) c.DataSize = nDefDataSize;
          strcpy(s, "Type");
          c.Type = Script_GetInt(sFile, szName, 0, (BOOL *)0) == 1 ? 2 : 0;
          strcpy(s, "EnableOnStart");
          c.EnableOnStart = c.Enabled = Script_GetBool(sFile, szName, FALSE, (BOOL *)0);

          // must realloc memory for the names
          if((names_base_size - names_base_used) < c.NameLen)
          {
            int   i;
            void *ptr = names_base ? realloc(names_base, names_base_size + 1024) :
                                     malloc (names_base_size + 1024);
            if(!ptr) goto next;
            names_base       = (char *)ptr;
            names_base_size += 1024;
            if(NumCheats > 0)
            {
              Cheats[0].Name = names_base;
              for(i = 1; i < NumCheats; i++)
                Cheats[i].Name = Cheats[i - 1].Name + Cheats[i - 1].NameLen;
            }
          }

          // copy the name
          c.Name = names_base + names_base_used;
          memcpy(c.Name, szBuf, c.NameLen);
          names_base_used += c.NameLen;

          // must realloc memory for address
          if((address_base_size - address_base_used) < c.NumAddress)
          {
            int   i;
            void *ptr = address_base ? realloc(address_base, (address_base_size + 256) * 4) :
                                       malloc ((address_base_size + 256) * 4);
            if(!ptr) goto next;
            address_base       = (unsigned long *)ptr;
            address_base_size += 256;
            if(NumCheats > 0)
            {
              Cheats[0].Address = address_base;
              for(i = 1; i < NumCheats; i++)
                Cheats[i].Address = Cheats[i - 1].Address + Cheats[i - 1].NumAddress;
            }
          }

          // copy the address
          c.Address = address_base + address_base_used;
          strcpy(s, "Address");
          Script_GetMultiInts(sFile, szName, (const int *)0, (int *)c.Address, c.NumAddress, (BOOL *)0);
          address_base_used += c.NumAddress;

          memcpy(Cheats + NumCheats++, &c, sizeof(CHEAT));
        }
      }
    }
  }

  Script_Free(sFile);

  return TRUE;
}

void Cheat_Quit(void)
{
  if(Cheats)       { free(Cheats);    Cheats    = (CHEAT *)0; }
  if(names_base)   { free(names_base); names_base = (char *)0; }
  if(address_base) { free(address_base); address_base = (unsigned long *)0; }
  NumCheats = names_base_size = names_base_used = address_base_size = address_base_used = 0;
}

#define write32a(addr, data) (*((unsigned long *) addr) = (unsigned long) data)

INLINE void write32u(void *addr, unsigned long data)
{
  (*((unsigned char *)addr))     = (unsigned char)data;
  (*((unsigned char *)addr + 1)) = (unsigned char)(data >> 8);
  (*((unsigned char *)addr + 2)) = (unsigned char)(data >> 16);
  (*((unsigned char *)addr + 3)) = (unsigned char)(data >> 24);
}

INLINE void write16(void *addr, unsigned long data)
{
  (*((unsigned char *)addr))     = (unsigned char)data;
  (*((unsigned char *)addr + 1)) = (unsigned char)(data >> 8);
}

#define write8(addr, data)  (*((unsigned char *)addr) = (unsigned char)data)

BOOL Cheat_Apply(void)
{
  int            i, j;
  unsigned char *m;

  if(!Cheats || NumCheats < 0) return FALSE;

  for(i = 0; i < NumCheats; i++)
  {
    if(Cheats[i].Enabled && Cheats[i].Type != 1)
    {
      for(j = 0; j < Cheats[i].NumAddress; j++)
      {
        m = System.RAM + Cheats[i].Address[j];
        switch(Cheats[i].DataSize)
        {
          case 32:
            if((unsigned)m & 3) write32u(m, Cheats[i].Value);
            else                write32a(m, Cheats[i].Value);
            break;
          case 16:
            write16(m, Cheats[i].Value);
            break;
          default:
            write8(m, Cheats[i].Value);
            break;
        }
      }
      if(Cheats[i].Type != 0) Cheats[i].Type = 1;
    }
  }

  return TRUE;
}
