/* Original PSG emulator by Maxim Gredy.
** Modified by Rodrigo Cardoso for SegaX. */

#ifndef _PSG_H
#define _PSG_H

#include "def.h"

#ifdef __cplusplus
extern "C" {
#endif

struct _PSG {
  float          Clock, dClock;
  int            PSGFrequencyLowBits;
  int            Channel;
  int            Stereo;
  int            NumClocksForSample;
  int            WhiteNoiseFeedback;
  unsigned short Registers[8];
  int            LatchedRegister;
  unsigned short NoiseShiftRegister;
  short          NoiseFreq;
  short          ToneFreqVals[4];    // Frequency register values (counters)
  char           ToneFreqPos[4];     // Frequency channel flip-flops
  short          Channels[4];        // Value of each channel, before stereo is applied
  long           IntermediatePos[4]; // intermediate values used at boundaries between + and -
  int            Mute;               // expose this for inspection/modification for channel muting
	int            VolumeArray;
} extern PSG;

void PSG_Init(unsigned long, unsigned long);
void PSG_Reset(void);
void PSG_Write(unsigned char);
void PSG_Update(int **, int);

#define PSG_GGStereoWrite(data) { PSG.Stereo = data; }


#ifdef __cplusplus
}
#endif

#endif // _PSG_H
